(*  w+ decay width into top + antibottom  *)

Clear[pt, pb, pw, mu]

PrepareIndex[mu]

SetMass[{pt, Mass[TopQuark]}, {pb, Mass[BottomQuark]}, {pw, Mass[WBoson]}]

mm = SpinorUbar[pt] ** 
	Vertex[TopQuark, BottomQuark, {WBoson, pw, mu}] ** SpinorV[pb] *
	HeavyVectorPolarization[pw, mu]

me2 = Contract[AbsSquared[mm], {mu, Conjugate[mu]}]

cc = DecayWidth[me2, pw->{0, 0, 0, Mass[WBoson]}, Spherical[pt, pb]]

result = Factor[Evaluate[cc]]
