PC::= PolarizationCombinations
MEps ::= MasslessVectorPolarization
HEps ::= HeavyVectorPolarization
S ::= SpinorS
T ::= SpinorT
CTTS ::= ConvertToST
STTT ::= STToTraces

Sph ::= Spherical
Cyl ::= Cylindrical
DW  ::= DecayWidth
Eval ::= EvaluatePhaseSpaceIntegrate
CEval ::= CEvaluatePhaseSpaceIntegrate
NEval ::= NEvaluatePhaseSpaceIntegrate
CS ::= CrossSection
Choose ::= ChooseLightlikeVectorNotCollinearWith
Pre ::= PrepareMatrixElementForCProgram

W ::= WBoson
Z ::= ZBoson
Elec ::= Electron
ElecNeu ::= ElectronNeutrino
Neu ::= Neutrino
CL ::= ChargedLepton
P ::= Photon
Up ::= UpQuark
Down ::= DownQuark

(* incoming momenta *)
(* w+ w- z order *)
WWZ[{p1_, p2_, p3_}, {mu1_, mu2_, mu3_}] := 
		Vertex[{W, p1, mu1}, {W, p2, mu2}, {Z, p3, mu3}]
WWZ[{p1_, p2_}, {mu1_, mu2_, mu3_}] := 
		Vertex[{W, p1, mu1}, {W, p2, mu2}, {Z, -p1-p2, mu3}]
(* w+ w- photon order *)
WWP[{p1_, p2_, p3_}, {mu1_, mu2_, mu3_}] := 
		Vertex[{W, p1, mu1}, {W, p2, mu2}, {P, p3, mu3}]
WWP[{p1_, p2_}, {mu1_, mu2_, mu3_}] := 
		Vertex[{W, p1, mu1}, {W, p2, mu2}, {P, -p1-p2, mu3}]
ffP[mu_] := Vertex[{CL}, {CL}, {P, 0, mu}]
ffP[ferm_, mu_] := Vertex[{ferm}, {ferm}, {P, 0, mu}]
ffW[ferm1_,ferm2_, mu_] := Vertex[{ferm1}, {ferm2}, {W, 0, mu}]
ffW[mu_] := Vertex[{CL}, {Neu}, {W, 0, mu}]
ffZ[ferm_, mu_] := Vertex[{ferm}, {ferm}, {Z, 0, mu}]
(* in the following 4-vector couplings pair the two w's *)
PZWW[mu1_, mu2_, mu3_, mu4_] :=
		Vertex[{W, 0, mu1}, {W, 0, mu2}, {Z, 0, mu3}, {P, 0, mu4}]
ZZWW[mu1_, mu2_, mu3_, mu4_] :=
		Vertex[{W, 0, mu1}, {W, 0, mu2}, {Z, 0, mu3}, {Z, 0, mu4}]
PPWW[mu1_, mu2_, mu3_, mu4_] :=
		Vertex[{W, 0, mu1}, {W, 0, mu2}, {P, 0, mu3}, {P, 0, mu4}]

FP ::= FermionPropagator
MFP ::= MasslessFermionPropagator
HVP ::= HeavyVectorPropagator
MVP ::= MasslessVectorPropagator

FermionPropagator[type_, p_] := Propagator[type][p]
MasslessFermionPropagator[p_] := Propagator[Neutrino][p]
MasslessVectorPropagator[{p_, mu1_, mu2_}] := 
		Propagator[MasslessVector][{p,mu1,mu2}]
MasslessVectorPropagator[p_] := Propagator[MasslessVector][p]
HeavyVectorPropagator[type_, p_] := Propagator[type][p]
HeavyVectorPropagator[type_, p_, mu1_, mu2_] := 
		Propagator[type][{p,mu1,mu2}]

HP::= HelicityProjection
SMass::=SetMass
SDP::=SetDotProduct
DPR::=DotProductRules
SMan::=SetMandelstam
MR::=MandelstamRules
Dir::= Direction
ES::= ExpandSlash
STD::=SpaceTimeDimension
Dg::=DiracGamma
DG::= DiracGamma
Conj::= Conjugate
Cont::= Contract
DP::= DotProduct
U::= SpinorU
Ubar::= SpinorUbar
V::= SpinorV
Vbar::= SpinorVbar
PL = HelicityProjection[Left]
PR = HelicityProjection[Right]
SR::= SetReal
Sl::= Slash
Tr::= Trace
AS ::= AbsSquared
DG5 ::= DiracGamma5
PI::= PrepareIndex
ENCM::= ExpandNonCommutativeMultiply
CTG5::= ConvertToGamma5
CTCF::=ConvertToChiralFermions
PF::=PhysicsForm
PFP::=PhysicsFormPrint
SNC::=SetNonCommutative
NCM::=NonCommutativeMultiply
NCE::=NonCommutativeExpand
NCF::=NonCommutativeFactor
CWE::=CollectWithoutExpanding
Com::=Commute
Comm::= Commute
L::=Left
R::=Right;
