typedef struct COMP {
    double re, im;
} complex_struct;

complex_struct *complex_stack;	/* a pointer to the beginning of the stack */
typedef int complex;		/* a complex is just an index in the stack */
int complex_size;		/* max. number of elements in current stack */
complex complex_current;	/* last used position in the stack */

#define COMPLEX(x) (*(complex_stack + (x)))
#define RE(x) (COMPLEX(x).re)
#define IM(x) (COMPLEX(x).im)

#define END -1

extern int complex_initialize();
extern complex get_temp_complex();
extern complex new_complex();
extern complex copy_complex();
extern void complex_restart();
extern void complex_terminate();
extern double Cabs();
extern double cabs_squared();
extern complex conjugate();
extern complex cexp();
extern double carg();
extern complex clog();
extern complex cpower();
extern complex csqrt();
extern complex dtoc();
extern void add_to();
extern complex mult_by_double();
extern void mult_by_complex();
extern complex cplus();
extern complex ctimes();
extern void cfprint();
extern void cprint();
