typedef struct FOUR {
    double x, y, z, t;
} fv_struct;

extern fv_struct *fv_stack;	/* a pointer to the beginning of the stack */
typedef int fv;		/* a fv is just an index in the stack */
extern int fv_size;		/* max. number of elements in current stack */
extern fv fv_current;	/* last used position in the stack */

/*	getting from a handle to a pointer to a struct */

#define FV(x) (fv_stack + (x))
#define DFV(x, i) ((double *) FV(x))[i]
#define X(p) (FV(p)->x)
#define Y(p) (FV(p)->y)
#define Z(p) (FV(p)->z)
#define T(p) (FV(p)->t)

extern int fv_initialize(int size);	/* call before using the stack */
extern fv get_temp_fv();	/* get a new (temporary) fv number */
extern fv new_fv( double x, double y, double z, double t); /* allocate a fv, 
							      and set its 
							      value */
extern fv copy_fv( fv p );
extern void fv_restart();
extern void fv_terminate();
extern fv fv_sum(fv fv1, fv fv2);
extern fv fv_difference(fv fv1, fv fv2);
extern double dot_product(fv p1, fv p2);
extern void fv_fprint(FILE *fo, fv p);
extern void fv_print(fv p);
extern complex spinor_s(fv p, fv q);
extern complex spinor_t(fv p, fv q);
extern double cosine(fv p, fv q);
extern double perpp(fv p);
extern fv opposite(fv p);
extern double mass(fv p);
extern double phase_space_factor(double m, double m1, double m2);
extern void decay(fv p0, double cth, double phi, double m1, double m2,
		  fv *r1, fv *r2, double *zaxis);
extern fv boost(fv p, double x);
