#include <math.h>
#include <stdio.h>
#include "mdefs.h"
#include "skel.h"
#include "complex.h"
#include "fv.h"
#include "vegas.h"
#include "sm.h"

double global_s = 250000.0;
extern double eeww();

double fn( double x[] )
{
  return eeww( x[1], x[2], x[3], x[4], x[5] );
}

main()
{
  double integral, sd, chisq;

  num_dim =  5;

  output_file=fopen("vegas.out","w");

  complex_initialize(100);
  fv_initialize(20);

/* limits of integrals go in here */
xl[1] = -1.;	xu[1] = 1.;
xl[2] = -1.;	xu[2] = 1.;
xl[3] = 0.;	xu[3] = 6.28319;
xl[4] = -1.;	xu[4] = 1.;
xl[5] = 0.;	xu[5] = 6.28319;

  calls = 1000;
  prn = 0;
  vegas (fn, &integral, &sd, &chisq);
  integral *= pb;
  sd *= pb;
  printf("\n\nThe integral is %e +/- %e (%e)\n",integral,sd,chisq);

  fclose(output_file);
  fv_terminate();
  complex_terminate();

  exit(0);
}
