#include "mdefs.h"
#include <math.h>
#include <stdio.h>
#include "skel.h"
#include "complex.h"
#include "fv.h"
#include "vegas.h"
#include "sm.h"

#define e sqrt(4*PI*Alpha)
#define g (e/sqrt(SSTW))
#define s 1.0

#define NUM_DIMENSIONS <* SpinorTechniques`Private`numdim *>

#define MAX_BINS 50
#define MAX_ITERATIONS_1 3
#define MAX_ITERATIONS_2 1
#define NUM_CALLS_1 1000
#define NUM_CALLS_2 3000

double global_s = 1000000.0;
double ct;

double fn( double x[] )
{

/* SpinorTechniques`Private`anglefndeclarations */

/* insert declarations */
<* SpinorTechniques`Private`declarations *>

<* SpinorTechniques`Private`angledeclarations *>

<* SpinorTechniques`Private`fvdeclarations *>

<* SpinorTechniques`Private`compdeclarations *>

/* set up initial momenta here */
<* SpinorTechniques`Private`initmom *>

/* insert the decays here */
<* SpinorTechniques`Private`decays *>

/* insert defns of dotproducts here */
<* SpinorTechniques`Private`dotproducts *>

/* insert defns of S's and T's here */
<* SpinorTechniques`Private`stdefns *>

/* insert the integrand here */
<* SpinorTechniques`Private`integrand2 *>

fv_restart();
complex_restart();

/* insert the return statement */
<* SpinorTechniques`Private`returnstatement *>

}


main()
{

double integral, sd, chisq;
num_dim = NUM_DIMENSIONS;
bins_max = MAX_BINS ;

output_file=fopen("int.out","w");

complex_initialize(20);
fv_initialize(20);

/* limits of integrals go in here */
<* SpinorTechniques`Private`limits *>

/*
for (ct = -1.0; ct <= 1.0; ct += 0.1)
{
*/

/*  first refine the grid  */
max_it_num = MAX_ITERATIONS_1;
calls = NUM_CALLS_1;
prn = -1;
vegas (fn, &integral, &sd, &chisq);

/*  now calculate the integral  */
max_it_num = MAX_ITERATIONS_2;
calls = NUM_CALLS_2;
prn = -1;
vegas1 (fn, &integral, &sd, &chisq);

	integral *= pb;
	sd *= pb;

/*
printf("%g  %g\n", ct, integral);
*/

printf("\n\nThe integral is %e +/- %e (%e)\n",integral,sd,chisq);
fprintf(output_file,
        "\n\nThe integral is %e +/- %e (%e)\n",integral,sd,chisq);

/*
}
*/

fclose(output_file);
fv_terminate();
complex_terminate();

return 0;
}
