#define SQR(x) ((x)*(x))
#define PI M_PI

extern double global_s; /* Center of Mass Energy Squared, in units of GeV^2 */
#define ECM sqrt(global_s) /* Center of Mass Energy (GeV) */
#define XEMS (2.61121e-7/global_s) /* Electron Mass Squared */
#define XZM (91.0/ECM) /* Z Mass */
#define XZMS (8281.0/global_s) /* Z Mass Squared */
#define SSTW 0.228 /* Sin(Th_W)^2 */
#define CSTW (1.0-SSTW) /* Cos(Th_W)^2 */
#define STW sqrt(SSTW) /* Sin(Th_W) */
#define CTW sqrt(CSTW) /* Cos(Th_W) */
#define XWMS (XZMS*CSTW) /* W Mass Squared */
#define XWM sqrt(XWMS) /* W Mass */
#define Alpha (1.0/137.036) /* ElectroMagnetic Coupling Alpha */
#define LEFT 0 /* For helicity specification */
#define RIGHT 1
#define pb 0.38937966e9 / global_s
#define R (3/PI/Alpha/Alpha)
